`default_nettype none
module pwm(x, rot, clock, y);
	input wire [3:0] x; // Anders dan bij de buizen-DAC, daarbij had x een teken. Different from valve DAC, there x was signed.
	input wire [2:0] rot; // toevalsgetal, 0...7 met elk kans 1/8. random number, 0...7 each with probability 1/8
	input wire clock;
	output wire y;
	reg [3:0] hulp = 3'b000;
	reg [3:0] hulp2;
	reg [2:0] hulp3;
	reg [2:0] rotation = 3'b000;
	reg y_int;
	reg [2:0] count_int = 3'b000;
	always @ (posedge clock)
	begin
		if (count_int == 3'b000)
		begin
			count_int <= 3'b111;
			hulp[3:0] <= x[3:0];
			rotation <= rot;
		end
		else
			count_int <= count_int - 3'b001;
	end
	always @ *
	begin
		hulp2 = count_int + rotation;
		hulp3[2:0] = hulp2[2:0]; // hulp3 = hulp2 mod 8
		if (hulp3 < hulp)
			y_int = 1;
		else
			y_int = 0;
	end
	assign y = y_int;
endmodule
`default_nettype wire
